//+------------------------------------------------------------------+
//|                                                   SCALP_X_EA.mq4 |
//|                                                         forexmts |
//|                                                 forexmts@mail.ru |
//+------------------------------------------------------------------+

#property copyright "Josh"
#property link "https://www.mql5.com/en/users/jxptrade"
#property strict
#define OP_ALL -1
#include <stdlib.mqh>

#define rSTO "\\Indicators\\Stochastic_Pine.ex4"
#define cSTO "::Indicators\\Stochastic_Pine.ex4"
#resource rSTO

enum ENUM_LOT_CALC_MODE { Lot_Fixed,      //fixed
                          Lot_Auto,       //auto
                        };
enum ENUM_DIRECTION     { DIR_BOTH,       //Buy and Sell
                          DIR_BUY,        //Buy only
                          DIR_SELL        //Sell only
                        };
enum ENUM_FUNCTION_MODE { MODE_DEINIT = -1, MODE_INIT, MODE_WORK, MODE_GET, MODE_SET, MODE_CLEAN, MODE_OPNM, MODE_OPNP, MODE_CLS };
enum ENUM_DELETE_LABEL  { DEL_BYNAME, DEL_BYMASK };
enum ENUM_MESS_CATEGORY { MESS_DEINIT = -1, MESS_INIT, MESS_ORDCLOSE, MESS_ORDDELETE, MESS_ORDOPEN, MESS_ORDTRANSFORM, MESS_ORDMODIFY, MESS_FREEZELEVEL,
                          MESS_STOPLEVEL, MESS_MINLOT, MESS_SGNLMODIFY, MESS_SGNLCLOSE, MESS_SGNLOPEN, MESS_ERROR, MESS_CRITERROR, MESS_SGNLPLACE,
                          MESS_SGNLDELETE, MESS_STOPPED, MESS_INPUTCHECK, MESS_INITFAIL, MESS_ORDLOST, MESS_SCHEDULER, MESS_DAILYPROF, MESS_DAILYLOSS,
                          MESS_MONEY };
enum ENUM_CLOSE_MODE    { CLS_BYTYPE, CLS_BYTICKET };
enum ENUM_ERROR_TYPE    { ERR_ABORT, ERR_IGNORE, ERR_REPEAT };
enum ENUM_DESCR         { DESCR_BRIEF, DESCR_MED, DESCR_FULL };
enum ENUM_UNIT          { UN_PIPS,            //pips
                          UN_POINTS,          //points
                          };
enum ENUM_STYLE         { STL_STND,           //standard
                          STL_WIDE,           //wide
                          };
enum ENUM_TRADE_MODE    { TRD_REC,            //recovery
                          TRD_FLIP,           //flip
                          };

struct STRUCT_ORDER_INFO
   {
   int ticket;
   int magic;
   int type;
   double lot;
   double open;
   double close;
   double sl;
   double tp;
   double profit;
   datetime time;
   string comment;
   };

input string Section10 = "~~~~~~~~~EA BASIC~~~~~~~~~";//~~~~~~~~~EA BASIC~~~~~~~~~
input ENUM_TRADE_MODE enTradeMode = TRD_REC;          //Trading mode:
sinput ENUM_LOT_CALC_MODE enLotCalcMode = Lot_Fixed;  //Lot mode:
input double dLotValue = 0.1;                         //Lot size / per 1000$
input double dTakeProfit = 3;                         //Target (p)
input double dRiskMult = 50;                          //Risk Multiplyer
input uint uiRecTrades = 2;                           //Recovery Trades
input double dMaxSpread = 0;                          //Max spread (p)
sinput int iMagicNumber = 732710;                     //Magic number
input string sCommentary = "";                        //Comment
sinput ENUM_UNIT enUnit = UN_PIPS;                    //Measure in:
sinput uint uiAttempts = 10;                          //Attempts of opening
input string Section11 = "~~~~~~~STOCHASTIC 1~~~~~~~";//~~~~~~~STOCHASTIC 1~~~~~~~
input int iPeriodK1 = 14;                             //Length
input int iSmoothK1 = 14;                             //SmoothK
input int iSmoothD1 = 3;                              //SmoothD
input string Section12 = "~~~~~~~STOCHASTIC 2~~~~~~~";//~~~~~~~STOCHASTIC 2~~~~~~~
input int iPeriodK2 = 5;                              //Length
input int iSmoothK2 = 3;                              //SmoothK
input int iSmoothD2 = 3;                              //SmoothD
input string Section13 = "~~~~~~~EMA~~~~~~~";         //~~~~~~~EMA~~~~~~~
input int iEMALength = 200;                           //Length
input string Section20 = "~~~~~~~INFO PANEL~~~~~~~";  //~~~~~~~INFO PANEL~~~~~~~
sinput bool bInfo = true;                             //Info show
sinput uint uiInfoXCoord = 5;                        //Info X coord
sinput uint uiInfoYCoord = 30;                        //Info Y coord
sinput ENUM_BASE_CORNER enInfoCorner = CORNER_LEFT_UPPER; //Info corner
sinput ENUM_STYLE enInfoStyle = STL_STND;             //Panel style
sinput bool bMessAlert = true;                        //Show alert on error
sinput bool bMessSound = true;                        //Play sound on message
sinput bool bMessMail = false;                        //Send e-mail on message
sinput bool bMessPush = false;                        //Push-notification on message
sinput color clrVisTextColor = clrDeepSkyBlue;        //Text color
input string sVisFontName = "Arial";                  //Text font
sinput int iVisFontSize = 10;                         //Text size
extern color clrVisBackColor = clrNONE;               //Back color
sinput bool  bVisTransparent = false;                 //Transparent

//global variables
string sEAname = "SCALP_X";
string sEAvers = "v1.1";
string sOrdTypesArr[6] = {"buy","sell","buylimit","selllimit","buystop","sellstop"};
bool bError;
STRUCT_ORDER_INFO stcOrdOldArr[], stcOrdNewArr[];   //arrays containing order list with information
int iOrdTypeQuantArr[6], iOrdNewQuant = 0, iOrdOldQuant = 0;   //total and by-type quantity of orders
int iMlt;      //Multiplier for the point size
double dTickSize; //Tick size
datetime dtPrevBar[1] = {0};

bool bCloseBySLFlag = false; int iCloseBySLDir = -1;  //for flip mode

//objects
class CInfo; CInfo* pInfo;
class CMessage; CMessage* pMess;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
  //initialization
  bError = false;
  iMlt = 1; if (enUnit == UN_PIPS) iMlt = 10;
  if (clrVisBackColor == clrNONE) clrVisBackColor = (color)ChartGetInteger(0, CHART_COLOR_BACKGROUND);
  dTickSize = SymbolInfoDouble(_Symbol, SYMBOL_TRADE_TICK_SIZE);
  if (!MQLInfoInteger(MQL_TESTER)) CopyTime(NULL, 0, 1, 1, dtPrevBar);
  
  fEvents(MODE_INIT);
  pMess = new CMessage();
  pInfo = new CInfo();
  
  //input check
  if (dTickSize <= 0) { pMess.Show(MESS_INPUTCHECK, 0, 0, 0, "Can't calculate tick size"); bError = true; }
  if (dLotValue <= 0) { pMess.Show(MESS_INPUTCHECK, 0, 0, 0, "'Lot size/%' must be >0!"); bError = true; }
  if (dLotValue >= 10) MessageBox(StringFormat("LotSize = %.2f%s is extremely high!", dLotValue), StringFormat("%s_%s %s%s", sEAname, sEAvers, _Symbol, StringSubstr(EnumToString(ChartPeriod()), 6)), MB_OK|MB_ICONWARNING);
  if (StringLen(sCommentary) > 31 - 5) { pMess.Show(MESS_INPUTCHECK, 0, 0, 0, "Comment length is more than allowed!"); bError = true; }
  
  if (bError)
    {
    pMess.Show(MESS_STOPPED);
    if (MQLInfoInteger(MQL_OPTIMIZATION)) return(INIT_FAILED);  //skip this pass only during optimization
    }
  return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  delete pMess;
  delete pInfo;
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
  if(bError) { pInfo.Update(); return; }
  fEvents(MODE_WORK);
   
  ResetLastError();
  MqlRates stCurr[1]; ArraySetAsSeries(stCurr, true);
  if(CopyRates(NULL, 0, 1, ArraySize(stCurr), stCurr) != ArraySize(stCurr)) return;      //error
  if(_LastError == 4066 || _LastError == 4054 || _LastError == 4073) return;           //history is uploading
  
  int iCurrSpread = (int)SymbolInfoInteger(_Symbol, SYMBOL_SPREAD);
  static bool bRecovery = false;

  //--- flip mode
  if(enTradeMode == TRD_FLIP && iOrdNewQuant == 0)
    {
    bRecovery = fIsRecovery();
    if(bRecovery && bCloseBySLFlag)
      {
      //--- check for spread
      if(dMaxSpread <= 0 || iCurrSpread <= dMaxSpread * iMlt)
        {
        switch(iCloseBySLDir)
          {
          case OP_BUY:
            {
            double dNewLot = (dRiskMult / uiRecTrades) * fGetLastLot();
            fOrderOpen(OP_SELL, "[sell]", dNewLot, 0, 0, 0, "|rec|");
            break;
            }
          case OP_SELL:
            {
            double dNewLot = (dRiskMult / uiRecTrades) * fGetLastLot();
            fOrderOpen(OP_BUY, "[buy]", dNewLot, 0, 0, 0, "|rec|");
            break;
            }
          }
        bCloseBySLFlag = false;
        }
      }
    }
  
  //--- once per bar check
  if(stCurr[0].time != dtPrevBar[0])
    {
    //--- recovery mode
    bRecovery = fIsRecovery();
    
    //--- check for spread
    if(dMaxSpread <= 0 || iCurrSpread <= dMaxSpread * iMlt)
      {
      //--- get indicator values
      double dStoK1Curr = fGetStoch(STO_1, MODE_MAIN, 1);
      double dStoK2Curr = fGetStoch(STO_2, MODE_MAIN, 1);
      double dStoK2Prev = fGetStoch(STO_2, MODE_MAIN, 2);
      double dEMACurr = fGetEMA(1);
      
      //--- new entry signal
      bool bToBuy = iOrdNewQuant == 0 && dStoK2Prev < 50 && dStoK2Curr > 50 && dStoK1Curr < 50;
      bool bToSell = iOrdNewQuant == 0 && dStoK2Prev > 50 && dStoK2Curr < 50 && dStoK1Curr > 50;
      
      //--- open trade
      if(bToBuy)
        {
        double dNewLot =  bRecovery && enTradeMode == TRD_REC ? (dRiskMult / uiRecTrades) * fGetLastLot() : 0;
        fOrderOpen(OP_BUY, "[buy]", dNewLot, 0, 0, 0, bRecovery ? "|rec|" : "");
        }
      else
      if(bToSell)
        {
        double dNewLot = bRecovery && enTradeMode == TRD_REC ? (dRiskMult / uiRecTrades) * fGetLastLot() : 0;
        fOrderOpen(OP_SELL, "[sell]", dNewLot, 0, 0, 0, bRecovery ? "|rec|" : "");
        }
      }
    
    dtPrevBar[0] = stCurr[0].time;
    }
  
  pInfo.Update(iCurrSpread, bRecovery);
  }
//+------------------------------------------------------------------+
//| Extract recovery flag                                            |
//+------------------------------------------------------------------+
bool fExtractRec(string sText)
  {
  return(StringFind(sText, "|rec|") >= 0);
  }
//+------------------------------------------------------------------+
//| Find last non-recovery lotsize                                   |
//+------------------------------------------------------------------+
double fGetLastLot(void)
  {
  for(int i = OrdersHistoryTotal()-1; i >= 0; i--)
    if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) && OrderSymbol() == _Symbol && fIsMagic(OrderMagicNumber()) && OrderType() <= 1)
      {
      if(fExtractRec(OrderComment()) == false) return(OrderLots());
      }
  return(0);
  }
//+------------------------------------------------------------------+
//| Check for recovery                                               |
//+------------------------------------------------------------------+
bool fIsRecovery(void)
  {
  int iTradesSinceLoss = 0;
  bool bFoundLoss = false;
  for(int i = OrdersHistoryTotal()-1; i >= 0; i--)
    if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) && OrderSymbol() == _Symbol && fIsMagic(OrderMagicNumber()) && OrderType() <= 1)
      {
      if(OrderProfit() < 0) { bFoundLoss = true; break; }
      iTradesSinceLoss++;
      }
  return(bFoundLoss && iTradesSinceLoss < (int)uiRecTrades && uiRecTrades > 0);
  }
//+------------------------------------------------------------------+
//| Get stochastic value                                             |
//+------------------------------------------------------------------+
enum ENUM_STOCH { STO_1=1, STO_2=2 };
double fGetStoch(ENUM_STOCH enNum, int iBuf, int iPos)
  {
  switch(enNum)
    {
    case STO_1: return(iCustom(NULL, 0, cSTO, iPeriodK1, iSmoothD1, iSmoothK1, iBuf, iPos));
    case STO_2: return(iCustom(NULL, 0, cSTO, iPeriodK2, iSmoothD2, iSmoothK2, iBuf, iPos));
    }
  return(0);
  }
//+------------------------------------------------------------------+
//| Get EMA value                                                    |
//+------------------------------------------------------------------+
double fGetEMA(int iPos)
  {
  return(iMA(NULL, 0, iEMALength, 0, MODE_EMA, PRICE_CLOSE, iPos));
  }
//+------------------------------------------------------------------+
//| forexmts, forexmts@mail.ru, v4.0vs-                              |
//| Order accounting function,                                       |
//| current state is stored in dOrdNewArr array                      |
//| previous state is stored in dOrdOldArr array                     |
//| iOrdTypeQuantArr array contains order quantity by type           |
//+------------------------------------------------------------------+
void fOrders()
  {
  int iQuant = 0;                          //orders counter initialization
  
  fArrayCopy(stcOrdOldArr, stcOrdNewArr);                //save new array to old array
  iOrdOldQuant = ArraySize(stcOrdNewArr);
  ArrayResize(stcOrdNewArr, 0);
  ArrayInitialize(iOrdTypeQuantArr, 0);                 //initialize order type array with zeros
  
  for(int i = 0; i < OrdersTotal(); i++)
    {
    if(OrderSelect(i, SELECT_BY_POS) && OrderSymbol() == _Symbol && fIsMagic(OrderMagicNumber()))
      {
      if (ArraySize(stcOrdNewArr) <= iQuant)        //add index to array if necessary
        {
        ArrayResize(stcOrdNewArr, iQuant+1, 10);
        }
       
      stcOrdNewArr[iQuant].ticket = OrderTicket();          //order ticket
      stcOrdNewArr[iQuant].magic = OrderMagicNumber();     //order magic number
      stcOrdNewArr[iQuant].type = OrderType();            //order type
      stcOrdNewArr[iQuant].lot = OrderLots();            //order volume
      stcOrdNewArr[iQuant].open = OrderOpenPrice();       //order open price
      stcOrdNewArr[iQuant].close = OrderClosePrice();
      stcOrdNewArr[iQuant].profit = OrderProfit()+OrderSwap()+OrderCommission();
      stcOrdNewArr[iQuant].time = OrderOpenTime();
      stcOrdNewArr[iQuant].sl = OrderStopLoss();
      stcOrdNewArr[iQuant].tp = OrderTakeProfit();
      stcOrdNewArr[iQuant].comment = OrderComment();      //order comment
      
      iOrdTypeQuantArr[stcOrdNewArr[iQuant].type]++;                //orders of certain type quantity
      iQuant++;                                       //order index
      }
    }  //for
  
  iOrdNewQuant = ArraySize(stcOrdNewArr);                            //total orders quantity
  }
//+------------------------------------------------------------------+
bool fIsMagic(long lMagic) { if (lMagic == iMagicNumber) return(true); else return(false); }
//+------------------------------------------------------------------+
//| forexmts, forexmts@mail.ru, v4.1vs-                              |
//| Error handling function,                                         |
//| performs necessary actions when an error occurs                  |
//+------------------------------------------------------------------+
ENUM_ERROR_TYPE fErrors()
  {
  if (_LastError == ERR_NO_ERROR) return(ERR_IGNORE);            //0
  
  switch(_LastError)
    {
    //negligible errors
    case ERR_COMMON_ERROR:                                      //2 - sometimes happens when trying to open order, reason is unknown
    case ERR_INVALID_TRADE_PARAMETERS:                          //3
    case ERR_SERVER_BUSY:                                       //4
    case ERR_NO_CONNECTION:                                     //6
    case ERR_TOO_FREQUENT_REQUESTS:                             //8
    case ERR_INVALID_PRICE:                                     //129
    case ERR_INVALID_STOPS:                                     //130
    case ERR_INVALID_TRADE_VOLUME:                              //131
    case ERR_PRICE_CHANGED:                                     //135   
    case ERR_OFF_QUOTES:                                        //136
    case ERR_BROKER_BUSY:                                       //137
    case ERR_REQUOTE:                                           //138
    case ERR_ORDER_LOCKED:                                      //139
    case ERR_TOO_MANY_REQUESTS:                                 //141
    case ERR_TRADE_MODIFY_DENIED:                               //145
    case ERR_TRADE_CONTEXT_BUSY:                                //146
      pMess.Show(MESS_ERROR, _LastError);
      Sleep(500);
      return(ERR_REPEAT);
    //critical errors
    case ERR_OLD_VERSION:                                       //5
    case ERR_NOT_ENOUGH_RIGHTS:                                 //7
    case ERR_MALFUNCTIONAL_TRADE:                               //9
    case ERR_ACCOUNT_DISABLED:                                  //64
    case ERR_INVALID_ACCOUNT:                                   //65
    case ERR_MARKET_CLOSED:                                     //132
      //bWorkingFlag = false;
      pMess.Show(MESS_CRITERROR, _LastError);
      return(ERR_ABORT);
    //ignorable errors
    case ERR_NO_RESULT:                                         //1
    case ERR_TRADE_TIMEOUT:                                     //128 - result unknown
    case ERR_TRADE_DISABLED:                                    //133
    case ERR_NOT_ENOUGH_MONEY:                                  //134
    case ERR_LONG_POSITIONS_ONLY_ALLOWED:                       //140
    case ERR_TRADE_EXPIRATION_DENIED:                           //147
    case ERR_TRADE_TOO_MANY_ORDERS:                             //148 
    case ERR_TRADE_HEDGE_PROHIBITED:                            //149
    case ERR_TRADE_PROHIBITED_BY_FIFO:                          //150
    default:
      pMess.Show(MESS_ERROR, _LastError);
      Sleep(500);
      return(ERR_REPEAT);
    }
  }
//+------------------------------------------------------------------+
//| forexmts, forexmts@mail.ru, v6.0vs-sltp+                         |
//| Open order function                                              |
//| opens market/places pending order                                |
//| number of tries is defined by Attempts input variable            |
//+------------------------------------------------------------------+
int fOrderOpen(int iType, string sReason, double dLotSize, double dOpenPrice = 0, double dSL = 0.0, double dTP = 0.0, string sDescr = "", uint uiMaxTries = 0)
  {
  int iTicket = -1;
  if(uiMaxTries == 0) uiMaxTries = uiAttempts;
  
  for (uint uiTry = 1; iTicket < 0 && uiTry <= uiMaxTries; uiTry++)
    {      
    double dLot = 0;
    double dOpenPriceLevel = 0, dStopLossLevel = 0, dTakeProfitLevel = 0;
    string sComment = sCommentary+sDescr;
    color cEntryCol = CLR_NONE;
    datetime dtExp = 0;
    RefreshRates();
    switch(iType)
      {
      case OP_BUY:
        dOpenPriceLevel = Ask;
        cEntryCol = clrBlue;
        if (dSL > 0) dStopLossLevel = ND(dSL);   else if (dTakeProfit > 0) dStopLossLevel = ND(dOpenPriceLevel - iMlt * dTakeProfit * dRiskMult * _Point);
        if (dTP > 0) dTakeProfitLevel = ND(dTP); else if (dTakeProfit > 0) dTakeProfitLevel = ND(dOpenPriceLevel + iMlt * dTakeProfit * _Point);
        if (dLotSize > 0)
          dLot = fLots(MODE_OPNM, Lot_Fixed, dLotSize, iType);
        else
          dLot = fLots(MODE_OPNM, enLotCalcMode, dLotValue, iType);
        if (dLot <= 0) return(0);                     //fLots() function returns zero value
        pMess.Show(MESS_SGNLOPEN, 0, 0.0, 0.0, pMess.OrdToStr(DESCR_MED, iType, dLot, dOpenPriceLevel), sReason);
        break;
      case OP_SELL:
        dOpenPriceLevel = Bid;
        cEntryCol = clrRed;
        if (dSL > 0) dStopLossLevel = ND(dSL);   else if (dTakeProfit > 0) dStopLossLevel = ND(dOpenPriceLevel + iMlt * dTakeProfit * dRiskMult * _Point);
        if (dTP > 0) dTakeProfitLevel = ND(dTP); else if (dTakeProfit > 0) dTakeProfitLevel = ND(dOpenPriceLevel - iMlt * dTakeProfit * _Point);
        if (dLotSize > 0)
          dLot = fLots(MODE_OPNM, Lot_Fixed, dLotSize, iType);
        else
          dLot = fLots(MODE_OPNM, enLotCalcMode, dLotValue, iType);
        if (dLot <= 0) return(0);                     //fLots() function returns zero value
        pMess.Show(MESS_SGNLOPEN, 0, 0.0, 0.0, pMess.OrdToStr(DESCR_MED, iType, dLot, dOpenPriceLevel), sReason);
        break;
      case OP_BUYLIMIT:
      case OP_BUYSTOP:
        dOpenPriceLevel = ND(dOpenPrice);
        if((iType == OP_BUYLIMIT && dOpenPriceLevel >= Ask) || (iType == OP_BUYSTOP && dOpenPriceLevel <= Ask)) dOpenPriceLevel = 0;
        if (dOpenPriceLevel <= 0) return(0);
        cEntryCol = clrBlue;
        if (dSL > 0) dStopLossLevel = ND(dSL);   else if (dTakeProfit > 0) dStopLossLevel = ND(dOpenPriceLevel - iMlt * dTakeProfit * dRiskMult * _Point);
        if (dTP > 0) dTakeProfitLevel = ND(dTP); else if (dTakeProfit > 0) dTakeProfitLevel = ND(dOpenPriceLevel + iMlt * dTakeProfit * _Point);
        if (dLotSize > 0)
          dLot = fLots(MODE_OPNP, Lot_Fixed, dLotSize, iType);
        else
          dLot = fLots(MODE_OPNP, enLotCalcMode, dLotValue, iType);
        if (dLot <= 0) return(0);                     //fLots() function returns zero value
        pMess.Show(MESS_SGNLOPEN, 0, 0.0, 0.0, pMess.OrdToStr(DESCR_MED, iType, dLot, dOpenPriceLevel), sReason);
        break;
      case OP_SELLLIMIT:
      case OP_SELLSTOP:
        dOpenPriceLevel = ND(dOpenPrice);
        if((iType == OP_SELLLIMIT && dOpenPriceLevel <= Bid) || (iType == OP_SELLSTOP && dOpenPriceLevel >= Bid)) dOpenPriceLevel = 0;
        if (dOpenPriceLevel <= 0) return(0);
        cEntryCol = clrRed;
        if (dSL > 0) dStopLossLevel = ND(dSL);   else if (dTakeProfit > 0) dStopLossLevel = ND(dOpenPriceLevel + iMlt * dTakeProfit * dRiskMult * _Point);
        if (dTP > 0) dTakeProfitLevel = ND(dTP); else if (dTakeProfit > 0) dTakeProfitLevel = ND(dOpenPriceLevel - iMlt * dTakeProfit * _Point);
        if (dLotSize > 0)
          dLot = fLots(MODE_OPNP, Lot_Fixed, dLotSize, iType);
        else
          dLot = fLots(MODE_OPNP, enLotCalcMode, dLotValue, iType);
        if (dLot <= 0) return(0);                     //fLots() function returns zero value
        pMess.Show(MESS_SGNLOPEN, 0, 0.0, 0.0, pMess.OrdToStr(DESCR_MED, iType, dLot, dOpenPriceLevel), sReason);
        break;
      }
    
    iTicket = OrderSend(_Symbol, iType, dLot, dOpenPriceLevel, 0, dStopLossLevel, dTakeProfitLevel, sComment, iMagicNumber, dtExp, cEntryCol);
    
    fEvents(MODE_WORK);                           //call events check function
    
    if(iTicket > 0 && iType <= 1 && OrderSelect(iTicket, SELECT_BY_TICKET)) //succesfully opened market order
      {
      switch(iType)
        {
        case OP_BUY:
          if (dSL > 0) dStopLossLevel = ND(dSL);   else if (dTakeProfit > 0) dStopLossLevel = ND(OrderOpenPrice() - iMlt * dTakeProfit * dRiskMult * _Point);
          if (dTP > 0) dTakeProfitLevel = ND(dTP); else if (dTakeProfit > 0) dTakeProfitLevel = ND(OrderOpenPrice() + iMlt * dTakeProfit * _Point);
          break;
        case OP_SELL:
          if (dSL > 0) dStopLossLevel = ND(dSL);   else if (dTakeProfit > 0) dStopLossLevel = ND(OrderOpenPrice() + iMlt * dTakeProfit * dRiskMult * _Point);
          if (dTP > 0) dTakeProfitLevel = ND(dTP); else if (dTakeProfit > 0) dTakeProfitLevel = ND(OrderOpenPrice() - iMlt * dTakeProfit * _Point);
          break;
        }
      fOrderModify(iTicket, OrderOpenPrice(), dStopLossLevel, dTakeProfitLevel, "[SLTP]");
      }
    else
    if(iTicket < 0)
      {
      ENUM_ERROR_TYPE enEType = fErrors();
      if (enEType == ERR_ABORT) break;           //abort
      if (enEType == ERR_IGNORE) iTicket = 0;     //no error
      }
    }  //for
  
  return(iTicket);
  }
//+------------------------------------------------------------------+
//| forexmts, forexmts@mail.ru, v6.3                                 |
//| Lot calculation function,                                        |
//| supports fixed lot, autolot based on margin and sl               |
//+------------------------------------------------------------------+
double fLots(ENUM_FUNCTION_MODE enMode, ENUM_LOT_CALC_MODE enLotMode, double dLotSize, int iType=-1, double dDist = 0)
  {
  switch (enMode)
    {
    case MODE_OPNM:
    case MODE_OPNP:
    case MODE_CLS:
      {
      double dMinLot = SymbolInfoDouble(_Symbol, SYMBOL_VOLUME_MIN);
      double dLotStep = SymbolInfoDouble(_Symbol, SYMBOL_VOLUME_STEP);
      double dMargin = MarketInfo(_Symbol, MODE_MARGINREQUIRED);
      double dTickValue = SymbolInfoDouble(_Symbol, SYMBOL_TRADE_TICK_VALUE);
      double dBalance = AccountInfoDouble(ACCOUNT_BALANCE);
      double dReturnValue = 0;
      
      switch(enLotMode)
        {
        case Lot_Fixed: dReturnValue = dLotSize; break;
        case Lot_Auto: dReturnValue = dBalance / 1000 * dLotSize; break;
        }
      
      if (dReturnValue > 0 && dReturnValue < dMinLot)
        {
        pMess.Show(MESS_MINLOT, 0, dReturnValue, dMinLot);
        dReturnValue = dMinLot;
        }
      dReturnValue = ND(dReturnValue / dLotStep, 0) * dLotStep;     //round down lot size
      
      //check for margin
      if (enMode == MODE_OPNM && dReturnValue > 0 && AccountFreeMarginCheck(_Symbol, iType, dReturnValue) < 0)
        {
        pMess.Show(MESS_MONEY, 0, 0, 0, pMess.OrdToStr(DESCR_BRIEF, iType, dReturnValue));
        return(0);
        }
      
      return(dReturnValue);
      }
    }  //switch
  return(0);
  }
//+------------------------------------------------------------------+
//| forexmts, forexmts@mail.ru, v3.3vs-                              |
//| Modify order function,                                           |
//| modifies currently existing order                                |
//| number of tries is defined by Attempts input variable            |
//+------------------------------------------------------------------+
bool fOrderModify(int iTicket, double dOpen, double dSL = 0, double dTP = 0, string sReason = "", uint uiMaxTries = 0)
  {
  bool bModResult = false;
  if(uiMaxTries == 0) uiMaxTries = uiAttempts;
  
  for (uint uiTry = 1; bModResult == false && uiTry <= uiMaxTries; uiTry++)
    if (OrderSelect(iTicket, SELECT_BY_TICKET) && OrderCloseTime() == 0)
      {
      if ((OrderType() <= 1 || fComp(OrderOpenPrice(), dOpen)) && fComp(OrderStopLoss(), dSL) && fComp(OrderTakeProfit(), dTP)) return(true);
      pMess.Show(MESS_SGNLMODIFY, 0, 0.0, 0.0, pMess.OrdToStr(DESCR_BRIEF, OrderType(), OrderLots()), sReason);
      ResetLastError();
      bModResult = OrderModify(iTicket, dOpen, dSL, dTP, OrderExpiration());
      
      fEvents(MODE_WORK);                           //call events check function
      if (bModResult == false)
        {
        ENUM_ERROR_TYPE enEType = fErrors();
        if (enEType == ERR_ABORT) break;                 //abort
        if (enEType == ERR_IGNORE) bModResult = true;    //no error
        }
      }
  return(bModResult);
  }
//+------------------------------------------------------------------+
//| forexmts, forexmts@mail.ru, v4.1vs-                              |
//| Events function,                                                 |
//| detects changes in orders list                                   |
//| uses fMessages() function to show that information               |
//+------------------------------------------------------------------+
void fEvents(ENUM_FUNCTION_MODE enMode)
  {   
  switch(enMode)
    {
    case MODE_INIT:
      fOrders();
      return;
    case MODE_WORK:
      {
      bool bFoundFlag;
      fOrders();
      //existing orders check
      for(int i = 0; i < iOrdOldQuant; i++)  //search all orders from the old array
        {
        bFoundFlag = false;
        for(int j = 0; j < iOrdNewQuant; j++) //.. in the new array
          {         
          if (stcOrdOldArr[i].ticket == stcOrdNewArr[j].ticket) //found by ticket 
            {
            if (stcOrdOldArr[i].type != stcOrdNewArr[j].type) //but the type has changed
              {
              pMess.Show(MESS_ORDTRANSFORM, 0, 0.0, 0.0, pMess.OrdToStr(DESCR_BRIEF, stcOrdNewArr[j].type, stcOrdNewArr[j].lot));      //show message
              }
            if (stcOrdOldArr[i].sl != stcOrdNewArr[j].sl) pMess.Show(MESS_ORDMODIFY, 0, stcOrdOldArr[i].sl, stcOrdNewArr[j].sl, pMess.OrdToStr(DESCR_BRIEF, stcOrdNewArr[j].type, stcOrdNewArr[j].lot), "[SL]"); //SL was changed
            if (stcOrdOldArr[i].tp != stcOrdNewArr[j].tp) pMess.Show(MESS_ORDMODIFY, 0, stcOrdOldArr[i].tp, stcOrdNewArr[j].tp, pMess.OrdToStr(DESCR_BRIEF, stcOrdNewArr[j].type, stcOrdNewArr[j].lot), "[TP]"); //TP was changed
            
            bFoundFlag = true;
            break;                              //stop searching in the new array
            }
          }
        
        if (bFoundFlag == false)                 //order wasn't found
          {
          if (stcOrdOldArr[i].type <= 1)
            //we can't use profit and close price, lots and commentary (for partial close) from the dOrdOldArr, because we need their after close values
            if (OrderSelect(stcOrdOldArr[i].ticket, SELECT_BY_TICKET))
              {
              if (stcOrdOldArr[i].sl > 0 && ((OrderType() == OP_BUY && OrderClosePrice() <= stcOrdOldArr[i].sl) || (OrderType() == OP_SELL && OrderClosePrice() >= stcOrdOldArr[i].sl) || StringFind(OrderComment(), "[sl]") >= 0))
                {
                pMess.Show(MESS_ORDCLOSE, 0, OrderProfit()+OrderSwap()+OrderCommission(), 0.0, pMess.OrdToStr(DESCR_MED, stcOrdOldArr[i].type, stcOrdOldArr[i].lot, OrderClosePrice()), "[SL]"); //close by sl
                bCloseBySLFlag = true;
                iCloseBySLDir = stcOrdOldArr[i].type;
                }
              else
              if (stcOrdOldArr[i].tp > 0 && ((OrderType() == OP_BUY && OrderClosePrice() >= stcOrdOldArr[i].tp) || (OrderType() == OP_SELL && OrderClosePrice() <= stcOrdOldArr[i].tp) || StringFind(OrderComment(), "[tp]") >= 0))
                pMess.Show(MESS_ORDCLOSE, 0, OrderProfit()+OrderSwap()+OrderCommission(), 0.0, pMess.OrdToStr(DESCR_MED, stcOrdOldArr[i].type, stcOrdOldArr[i].lot, OrderClosePrice()), "[TP]"); //close be tp
              else
                pMess.Show(MESS_ORDCLOSE, 0, OrderProfit()+OrderSwap()+OrderCommission(), 0.0, pMess.OrdToStr(DESCR_MED, stcOrdOldArr[i].type, stcOrdOldArr[i].lot, OrderClosePrice()));         //ordinary close
              }
            else
              pMess.Show(MESS_ORDLOST, stcOrdOldArr[i].ticket);
            
          if (stcOrdOldArr[i].type > 1)
            pMess.Show(MESS_ORDDELETE, 0, 0.0, 0.0, pMess.OrdToStr(DESCR_MED, stcOrdOldArr[i].type, stcOrdOldArr[i].lot, stcOrdOldArr[i].open));      //pending order is deleted
          }
        }
      
      //new orders check
      for(int j = 0; j < iOrdNewQuant; j++)   //search all orders from the new array
        {      
        bFoundFlag = false;
        for(int i = 0; i < iOrdOldQuant; i++)   //..in the old array
          {
          if (stcOrdNewArr[j].ticket == stcOrdOldArr[i].ticket) //found by ticket
            {
            bFoundFlag = true;
            break;                           //stop searching in the old array
            }
          }
        
        if (bFoundFlag == false)              //order wasn't found
          if (StringSubstr(stcOrdNewArr[j].comment, 0, 4) != "from")
            pMess.Show(MESS_ORDOPEN, 0, 0.0, 0.0, pMess.OrdToStr(DESCR_FULL, stcOrdNewArr[j].type, stcOrdNewArr[j].lot, stcOrdNewArr[j].open, stcOrdNewArr[j].sl, stcOrdNewArr[j].tp));   //new order
        }
      break;
      }
    } //switch
  
  }
//+------------------------------------------------------------------+
//| forexmts, forexmts@mail.ru, v4.0                                 |
//| Info Class,                                                      |
//| shows panel on the chart with various information                |
//+------------------------------------------------------------------+
class CInfo
  {
  private:
    bool m_bMode;
    ENUM_BASE_CORNER m_enCorner;
    int m_iXCoord;
    int m_iYCoord;
    int m_iWidth;
    int m_iHeight;
    ENUM_STYLE m_enStyle;
  
  public:
    void CInfo(void);
    void ~CInfo(void) { if (m_bMode) fDelLabel(DEL_BYMASK, "State"); }
    void Update(int iCurrSpread=0, bool bRecovery=false);
  };
void CInfo::CInfo(void): m_bMode(bInfo), m_enCorner(enInfoCorner), m_iXCoord((int)uiInfoXCoord), m_iYCoord((int)uiInfoYCoord), m_enStyle(enInfoStyle)
  {
  if (!m_bMode) return;
  
  double dWidthBase = 21;
  double dStepRow = 1.5;
  if (m_enStyle == STL_WIDE) { dWidthBase *= 1.5; dStepRow *= 1.2; }
  
  int iTotRows = 11;
  m_iWidth = int(dWidthBase*iVisFontSize);
  m_iHeight = int(dStepRow*iVisFontSize*iTotRows+10);
  
  int x=0, y=0, u=0, v=0;
  switch(m_enCorner)
    {
    case CORNER_LEFT_UPPER:   x = m_iXCoord; y = m_iYCoord; u = 1; v = 1; break;
    case CORNER_RIGHT_UPPER:  x = m_iWidth+m_iXCoord; y = m_iYCoord; u = -1; v = 1; break;
    case CORNER_LEFT_LOWER:   x = m_iXCoord; y = m_iHeight+m_iYCoord; u = 1; v= -1; break;
    case CORNER_RIGHT_LOWER:  x = m_iWidth+m_iXCoord; y = m_iHeight+m_iYCoord; u = -1; v = -1; break;
    }
  fDrawBack("State_Back", x, y, m_enCorner, m_iWidth, m_iHeight);
    
  x += u*5; y += v*5;
  fDrawLabel("State_Header",     x, y, m_enCorner, StringFormat("%s_%s:", sEAname, sEAvers), 1.2); y += int(v*dStepRow*iVisFontSize);
  fDrawLabel("State_Separator1", x, y, m_enCorner, "---------------settings---------------"); y += int(v*dStepRow*iVisFontSize);
  fDrawLabel("State_Mode:",      x, y, m_enCorner, StringFormat("Mode: %s", enTradeMode == TRD_REC ? "recovery" : "flip")); y += int(v*dStepRow*iVisFontSize);
  fDrawLabel("State_Lot",        x, y, m_enCorner, StringFormat("%s = %s", EnumToString(enLotCalcMode), StringFormat("%.2f%s", dLotValue, enLotCalcMode==Lot_Auto?" per 1000$":""))); y += int(v*dStepRow*iVisFontSize);
  fDrawLabel("State_Stops",      x, y, m_enCorner, StringFormat("SL = %s, TP = %s", dTakeProfit>0?StringFormat("%.1f p",dTakeProfit*dRiskMult):"off", dTakeProfit>0?StringFormat("%.1f p",dTakeProfit):"off")); y += int(v*dStepRow*iVisFontSize);
  fDrawLabel("State_Risk",       x, y, m_enCorner, StringFormat("RiskMult = %.1f, RecTrades = %i", dRiskMult, uiRecTrades)); y += int(v*dStepRow*iVisFontSize);
  fDrawLabel("State_Separator2", x, y, m_enCorner, "---------------current---------------"); y += int(v*dStepRow*iVisFontSize);
  fDrawLabel("State_Error",      x, y, m_enCorner, "", 2, NULL, clrTomato);
  fDrawLabel("State_Spread",   x, y, m_enCorner); y += int(v*dStepRow*iVisFontSize);
  fDrawLabel("State_Recovery", x, y, m_enCorner); y += int(v*dStepRow*iVisFontSize);
  fDrawLabel("State_Total",    x, y, m_enCorner); y += int(v*dStepRow*iVisFontSize);
  ChartRedraw();
  }
void CInfo::Update(int iCurrSpread=0, bool bRecovery=false)
  {
  if (!m_bMode) return;
  
  double dTotLot = 0, dTotProf = 0;
  for (int i = 0; i < ArraySize(stcOrdNewArr); i++)
    switch(stcOrdNewArr[i].type)
      {
      case OP_BUY: dTotLot += stcOrdNewArr[i].lot; dTotProf += stcOrdNewArr[i].profit; break;
      case OP_SELL: dTotLot -= stcOrdNewArr[i].lot; dTotProf += stcOrdNewArr[i].profit; break;
      }
  
  ObjectSetString(0, sEAname+"_State_Error",     OBJPROP_TEXT, bError?"ERROR!!!":"");
  ObjectSetString(0, sEAname+"_State_Spread",    OBJPROP_TEXT, bError?"":StringFormat("Spread = %.1fp, %s", iCurrSpread * 1.0 / iMlt, (dMaxSpread<=0 || iCurrSpread<=dMaxSpread*iMlt ? "allow" : "forbid")));
  ObjectSetString(0, sEAname+"_State_Recovery",  OBJPROP_TEXT, bError?"":StringFormat("Mode: %s", bRecovery ? "Recovery" : "Normal"));
  ObjectSetString(0, sEAname+"_State_Total",     OBJPROP_TEXT, bError?"":StringFormat("Total: %.2f %s = %+.2f %s", MathAbs(dTotLot), dTotLot>0?"BUY":(dTotLot<0?"SELL":""), dTotProf, AccountCurrency()));
  ChartRedraw();
  }
//+------------------------------------------------------------------+
//| forexmts, forexmts@mail.ru, v4.0 w/o visual                      |
//| Message Class,                                                   |
//| shows text notifications on the chart                            |
//| also shows pop-up alerts/sends e-mail if necessary               |
//+------------------------------------------------------------------+
class CMessage
  {
  public:
    void CMessage(void) { }
    void ~CMessage(void) { }
    void Show(ENUM_MESS_CATEGORY enMessNum, int iValue = 0, double dValue1 = 0.0, double dValue2 = 0.0, string sValue = "", string sReason = "");
    string OrdToStr(ENUM_DESCR enMode, int iType, double dLot, double dOpen=0, double dSL=0, double dTP=0);
  };
void CMessage::Show(ENUM_MESS_CATEGORY enMessNum, int iValue = 0, double dValue1 = 0.0, double dValue2 = 0.0, string sValue = "", string sReason = "")
  {
  string sText, sSound = "";
  bool bShowAlert = false;
  bool bShowPopup = false;
  
  switch(enMessNum)
    {
    case MESS_ORDCLOSE:
      sText = StringFormat("EVENT: closed %s %s = %.2f %s", sValue, sReason, dValue1, AccountCurrency());
      sSound = "ok.wav";
      bShowAlert = true;
      break;
    case MESS_ORDDELETE:
      sText = StringFormat("EVENT: deleted %s", sValue);
      sSound = "ok.wav";
      bShowAlert = true;
      break;
    case MESS_ORDOPEN:
      sText = StringFormat("EVENT: opened %s", sValue);
      sSound = "ok.wav";
      bShowAlert = true;
      break;
    case MESS_ORDTRANSFORM:
      sText = StringFormat("EVENT: %s is transformed into market", sValue);
      sSound = "ok.wav";
      bShowAlert = true;
      break;
    case MESS_ORDMODIFY:
      sText = StringFormat("EVENT: %s is modified %s: %s => %s", sValue, sReason, DTS(dValue1), DTS(dValue2));
      sSound = "stops.wav";
      bShowAlert = true;
      break;
    case MESS_FREEZELEVEL:
      sText = StringFormat("ERROR: can\'t modify, price %s is too close to the market", DTS(dValue1));
      break;
    case MESS_STOPLEVEL:
      sText = StringFormat("ERROR: can\'t set %s at %S => %S", sReason, DTS(dValue1), DTS(dValue2));
      break;
    case MESS_MINLOT:
      sText = StringFormat("MM: lot %.3f is less than min, increasing to %.2f", dValue1, dValue2);
      break;
    case MESS_SGNLMODIFY:
      sText = StringFormat("SGNL: trying to modify %s %s", sValue,  sReason);
      break;
    case MESS_SGNLCLOSE:
      sText = StringFormat("SGNL: trying to close %s %s", sValue, sReason);
      break;
    case MESS_SGNLOPEN:
      sText = StringFormat("SGNL: trying to open %s %s", sValue, sReason);
      break;
    case MESS_ERROR:
      sText = StringFormat("ERROR: %s", ErrorDescription(iValue));
      sSound = "timeout.wav";
      bShowAlert = true;
      break;
    case MESS_CRITERROR:
      sText = StringFormat("CRITICAL ERROR: %s", ErrorDescription(iValue));
      sSound = "timeout.wav";
      bShowAlert = true;
      bShowPopup = true;
      break;
    case MESS_SGNLPLACE:
      sText = StringFormat("SGNL: trying to place %s %s", sValue, sReason);
      break;
    case MESS_SGNLDELETE:
      sText = StringFormat("SGNL: trying to delete %s %s", sValue, sReason);
      break;
    case MESS_STOPPED:
      sText = "ERROR: stopped due to critical error.";
      bShowPopup = true;
      break;
    case MESS_INPUTCHECK:
      sText = "ERROR: " + sValue;
      bShowPopup = true;
      break;
    case MESS_ORDLOST:
      sText = StringFormat("ERROR: can\'t find order(#%i) Deleted by broker?", iValue);
      sSound = "timeout.wav";
      bShowAlert = true;
      break;
    case MESS_SCHEDULER:
      if (iValue == true) sText = "SCHED: trade is allowed"; else sText = "SCHED: trade is forbidden";
      break;
    case MESS_DAILYPROF:
      sText = "DAILY: profit is reached, close all";
      break;
    case MESS_DAILYLOSS:
      sText = "DAILY: loss is reached, close all";
      break;
    case MESS_MONEY:
      sText = StringFormat("MM: not enough money to open %s", sValue);
      sSound = "timeout.wav";
      break;
    }
  
  if (bMessAlert && bShowPopup) Alert(sText);
  else
  if (bMessSound && sSound != "") PlaySound(sSound);
  if (bMessMail && bShowAlert) SendMail(sEAname, sText);
  if (bMessPush && bShowAlert) SendNotification(sText);
  Print(sText);
  }
//+--------------------------------------------------------------------+
string CMessage::OrdToStr(ENUM_DESCR enMode, int iType, double dLot, double dOpen=0, double dSL=0, double dTP=0)
  {
  string sDescr = StringFormat("%s%.2f", sOrdTypesArr[iType], dLot);
  if (enMode != DESCR_BRIEF) sDescr += StringFormat("/%s", DTS(dOpen));
  if (enMode == DESCR_FULL) sDescr += StringFormat("/%s/%s", DTS(dSL), DTS(dTP));
  return (sDescr);
  }
//+------------------------------------------------------------------+
//| forexmts, forexmts@mail.ru, v3.0                                 |
//| Visualization function:                                          |
//| draws/deletes text label on the chart                            |
//| hidden, non-selectable, non-hint labels                          |
//+------------------------------------------------------------------+
void fDrawBack(string sName, int iX, int iY, ENUM_BASE_CORNER enCorner, int iHeight, int iWidth, color clrFColor = CLR_NONE)
  {
  string sObjName = sEAname + "_" + sName;
  if (ObjectFind(0, sObjName) == -1)
    {
    ObjectCreate    (0, sObjName, OBJ_RECTANGLE_LABEL, 0, 0, 0);
    ObjectSetInteger(0, sObjName, OBJPROP_XDISTANCE, iX);
    ObjectSetInteger(0, sObjName, OBJPROP_YDISTANCE, iY);
    ObjectSetInteger(0, sObjName, OBJPROP_XSIZE, iHeight);
    ObjectSetInteger(0, sObjName, OBJPROP_YSIZE, iWidth);
    ObjectSetInteger(0, sObjName, OBJPROP_CORNER, enCorner);
    ObjectSetInteger(0, sObjName, OBJPROP_BORDER_TYPE, BORDER_RAISED);
    ObjectSetInteger(0, sObjName, OBJPROP_BACK, bVisTransparent);
    ObjectSetInteger(0, sObjName, OBJPROP_BGCOLOR, clrFColor==CLR_NONE?clrVisBackColor:clrFColor);
    ObjectSetInteger(0, sObjName, OBJPROP_SELECTABLE, false);
    ObjectSetInteger(0, sObjName, OBJPROP_HIDDEN, true);
    }
  }
void fDrawLabel(string sName, int iX, int iY, ENUM_BASE_CORNER enCorner, string sText = "", double dSize = 1, string sFName = "", color clrFColor = CLR_NONE, bool bBack = false)
  {
  string sObjName = sEAname + "_" + sName;
  if (ObjectFind(0, sObjName) == -1)
    {
    ObjectCreate    (0, sObjName, OBJ_LABEL, 0, 0, 0);
    ObjectSetInteger(0, sObjName, OBJPROP_XDISTANCE, iX);
    ObjectSetInteger(0, sObjName, OBJPROP_YDISTANCE, iY);
    ObjectSetInteger(0, sObjName, OBJPROP_CORNER, enCorner);
    ObjectSetInteger(0, sObjName, OBJPROP_BACK, bBack);
    ObjectSetInteger(0, sObjName, OBJPROP_COLOR, clrFColor==CLR_NONE?clrVisTextColor:clrFColor);
    ObjectSetInteger(0, sObjName, OBJPROP_FONTSIZE, int(dSize * iVisFontSize));
    ObjectSetString (0, sObjName, OBJPROP_FONT, sFName==""?sVisFontName:sFName);
    ObjectSetString (0, sObjName, OBJPROP_TOOLTIP, "\n");
    ObjectSetInteger(0, sObjName, OBJPROP_SELECTABLE, false);
    ObjectSetInteger(0, sObjName, OBJPROP_HIDDEN, true);
    }
  ObjectSetString(0, sObjName, OBJPROP_TEXT, sText);
  }
void fDelLabel(ENUM_DELETE_LABEL enMode, string sName)
  {
  string sObjName = sEAname + "_" + sName;
  switch(enMode)
    {
    case DEL_BYNAME:
      if (ObjectFind(0, sObjName) >= 0) ObjectDelete(0, sObjName);
      break;
    case DEL_BYMASK:
      ObjectsDeleteAll(0, sObjName);
      break;
    }
  }
//+------------------------------------------------------------------+
//| Compare two double type values:                                  | 
//| uses Digits precision                                            |
//+------------------------------------------------------------------+
bool fComp(double dValue1, double dValue2)
   {
   if (NormalizeDouble(dValue1 - dValue2, _Digits) == 0)
      return(true);
   else
      return(false);
   }
//+------------------------------------------------------------------+
//| Normalization of double type value:                              |
//| uses Digits precision by default                                 |
//+------------------------------------------------------------------+
double ND(double dValue, int iDig = -1)
   {
   if (iDig == -1)
      return(MathRound(dValue / dTickSize) * dTickSize);
   else
    return(NormalizeDouble(dValue, iDig));
   }
string DTS(double dValue, int iDig = -1)
  {
  if (iDig == -1) iDig = _Digits;
  return(DoubleToString(dValue, iDig));
  }
string ITS(int iValue) { return(IntegerToString(iValue)); }
int STI(string sValue) { return((int)StringToInteger(sValue)); }
//+------------------------------------------------------------------+
//| coppy array of structures                                        |
//+------------------------------------------------------------------+
template <typename T> 
void fArrayCopy(T& dst_array[], const T&  src_array[])
  { 
  int iSize = ArraySize(src_array);
  ArrayResize(dst_array, iSize);
  for (int i = 0; i < iSize; i++)
    dst_array[i] = src_array[i];
  }